#include <cstdio>
#include <iostream>
#include <string>
#include <set>
#include <vector>
#include <algorithm>
#define MAXD 0x1000
#define MAXS 0x1000
#define MAX 0x1000
using namespace std;

struct NODE
{
	string word;
	vector<bool> pos;
	long* offset;
};

struct NODE_CMP
{
	bool operator() (NODE a,NODE b)
	{	
		//return a.pos>b.pos;
		int i;
		for(i=0;i<min(a.pos.size(),b.pos.size());i++)
		{
			if(a.pos[i]!=b.pos[i])
				return a.pos[i]>b.pos[i];
		}
		if(a.pos.size()>b.pos.size())
			return a.pos[i]!=0;
		return 1;
	}
};
typedef set<NODE>::iterator it;
set<NODE,NODE_CMP> tree;
vector<it> line[MAXD];
long offsets[MAX];
int main()
{
	it i;
	int l=-1,maxl=0;
	char c,to_word=0,lft=1;
	int x,y,boza;
	int n,m;
	vector<char> buff;
	vector<bool> pos;
	NODE tmp;
	pair<it,bool> p;
	c=getchar();
	while(c!='\n')
	{
		if(to_word)
		{
			buff.push_back(c);
			if(c=='"')
			{
				tmp.word.assign(buff.begin(),buff.end());
				buff.clear();
				to_word=0;
				tmp.pos=pos;
				tmp.offset=offsets+tree.size();
				p=tree.insert(tmp);
				line[l].push_back(p.first);
			}
		}
		else
		{
			if(c=='"')
			{
				to_word=1;
				buff.push_back(c);
			}
			if(c=='(')
			{
				l++;
				if(l>=maxl)
					maxl=l+1;
				if(lft)
					pos.push_back(0);	
				else
					pos.push_back(1);
				lft=0;
			}
			if(c==')')
			{
				l--;
				lft=1;
				pos.pop_back();
			}
		}
		c=getchar();
	}
	cin>>m>>n;
	l=0;
	for(i=tree.begin();i!=tree.end();i++)
	{
		*(*i).offset=l;
		l+=(*i).word.size()+m;
		//cout<<(*i).word<<" ";
	}
	//cout<<endl;
	maxl--;
	for(x=0;x<maxl;x++)
	{
		for(y=0,l=0;y<line[x].size();y++)
		{
			for(boza=0;boza<((*(*line[x][y]).offset)-l);boza++)
				cout<<" ";
			cout<<(*line[x][y]).word;
			l=(*line[x][y]).word.size()+(*(*line[x][y]).offset);
		}
		if(x<maxl-1)
		{
			for(boza=0;boza<=n;boza++)
				cout<<endl;
		}
		else
			cout<<"\n";
	}
}
