#include <stdio.h>
#include <stdlib.h>
#define MAXN 20000

int k, n, nn, px[MAXN], py[MAXN], ps[MAXN], pst[MAXN], pstl;
bool in[MAXN];

int area(int a, int b, int c){
  return (px[b] - px[a])*(py[c] - py[a]) - (py[b] - py[a])*(px[c] - px[a]);
      
}

bool left(int a, int b, int c){
  return area(a, b, c) > 0;     
}

bool lefteq(int a, int b, int c){
  return area(a, b, c) >= 0;
}

bool coll(int a, int b, int c){
  return area(a, b, c) == 0;     
}

int cmpgr(const void *pa, const void *pb){
  int a = *(int*)pa, b = *(int*)pb;
  if(left(ps[0], b, a)) return 1;
  if(left(ps[0], a, b)) return -1;
  
  if(
  (px[a] - px[ps[0]])*(px[a] - px[ps[0]]) + (py[a] - py[ps[0]])*(py[a] - py[ps[0]]) > 
  (px[b] - px[ps[0]])*(px[b] - px[ps[0]]) + (py[b] - py[ps[0]])*(py[b] - py[ps[0]])
  )return 1;
  else return -1;
}

void chull(){
  int m = 0, i, t;
  for(i = 1; i < n; i++)
  if(px[ps[i]] < px[ps[m]] || (px[ps[i]] == px[ps[m]] && py[ps[i]] < py[ps[m]])) m = i;
  t = ps[m];
  ps[m] = ps[0];
  ps[0] = t;
  qsort(ps + 1, n - 1, sizeof(int), cmpgr);
  /*
  for(i = 0; i < n; i++)
  printf("%d ", ps[i] + 1);  
  printf("\n");
  */
  pstl = 3;
  pst[0] = 0;
  pst[1] = 1;
  pst[2] = 2;
  for(i = 3; i < n; i++){
    pst[pstl] = i;
    pstl++;
    while(lefteq(ps[pst[pstl-3]], ps[pst[pstl-1]], ps[pst[pstl-2]])){
      pst[pstl-2] = pst[pstl-1];
      pstl--;                       
    }          
  }

  while(coll(ps[0], ps[pst[pstl-1]], ps[pst[pstl-1]-1])){
    pst[pstl] = pst[pstl-1] -1;
    pstl++;                  
  }
  /*
  printf("h: ");
  for(i = 0; i < pstl; i++)
  printf("%d ", ps[pst[i]] + 1);
  printf("\n\n");
  */

}

void achull(){
  int i;
  for(i = 0; i < pstl; i++)
  in[ps[pst[i]]] = false;
  
  n = 0;
  for(i = 0; i < nn; i++)
  if(in[i]){
    ps[n] = i;
    n++;          
  }
  /*
  printf("n: ");
  for(i = 0; i < n; i++)
  printf("%d ", ps[i] + 1);    
  printf("\n\n"); 
  */

}

int solve(){
  int r = -1;
  while(in[k]){
    chull();
    achull();
    r++;             
  }
  return r;
}

int main(){
  int i;
  scanf("%d\n", &nn);
  n = nn;
  for(i = 0; i < n; i++){
    in[i] = true;
    ps[i] = i;
    scanf("%d %d", px + i, py + i);
  }
  scanf("%d", &k);    
  k--;  
  printf("%d\n", solve());
}
