#include <cstdio>
#include <algorithm>
#include <iostream>

#define INFINITY 131231231

using namespace std;

struct Points
{ int x, y, index; };

struct Point
{
    int x,y;
    double cotg;
};

bool used[1<<14];
int n, k, size, ans, over;
Point start, need;
Point A[1<<14], B[1<<14];
Points stack[1<<14];

bool operator== (const Point &a, const Point &b)
{ return (a.x==b.x && a.y==b.y); }

bool operator< (const Point &a, const Point &b)
{
     if (a.y != b.y)
        return a.y < b.y;
     else
        return a.x < b.x;
}

inline double mod(double a)
{ return (a < 0) ? -a : a; }

bool cmp(const Point &a, const Point &b)
{
     if (a.cotg != b.cotg)
        return a.cotg > b.cotg;
     else if (a.y != b.y)
        return a.y < b.y;
     else
        return a.x < b.x; 
}

inline int check(int x1, int y1, int x2, int y2, int x3, int y3)
{ return x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2); }

void solve()
{
     start=A[0];
     for (int i=1; i<n; ++i)
         if (A[i] < start)
             start=A[i];
     for (int i=0; i<n; ++i)
         if (A[i].x!=start.x || A[i].y!=start.y)
         {
             if (A[i].y == start.y)
                A[i].cotg=INFINITY;
             else if (A[i].x == start.x)
                A[i].cotg=0;
             else
                A[i].cotg=mod(A[i].x-start.x)/mod(A[i].y-start.y);
         }
         else
             A[i].cotg=INFINITY;  
     sort(A, A+n, cmp);
     size=0;
     stack[size].x=start.x;
     stack[size++].y=start.y;
     stack[size].x=A[1].x;
     stack[size++].y=A[1].y;
     used[0]=1;
     used[1]=1;
     for (int i=2; i<n; ++i)
         if (A[i].x!=start.x || A[i].y!=start.y)
         {
             bool flag=false;
             while(!flag)
             {             
                int value=check(stack[size-2].x, stack[size-2].y, stack[size-1].x, stack[size-1].y, A[i].x, A[i].y);
                if (value > 0)
                {
                   used[i]=1;
                   stack[size].x=A[i].x;
                   stack[size].y=A[i].y;
                   stack[size++].index=i;
                   flag=true;
                }
                else if (value == 0)
                {
                     used[i]=1;
                     used[stack[size-1].index]=0;
                     stack[size-1].x=A[i].x;
                     stack[size-1].y=A[i].y;
                     stack[size-1].index=i;
                     flag=true;
                }
                else
                {
                    used[stack[size-1].index]=0;
                    --size;
                }
             }
         }
}

void input()
{
     scanf("%d", &n);
     for (int i=0; i<n; ++i)
         scanf("%d%d", &A[i].x, &A[i].y);
     scanf("%d", &k);
     need=A[k-1];
}

int main()
{
    input();
    while(1)
    {
         ++ans;
         solve();
         memcpy(B, A, sizeof(A));
         int d=n;
         n=0;
         for (int i=0; i<d; ++i)
             if (!used[i])
                A[n++]=B[i];
             else
                if (B[i] == need)
                {
                         printf("%d\n", ans-1);
                         return 0;
                }
         memset(used, 0, sizeof(used));
    }
return 0;
}
