#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#define MAXN 16384
struct _POINT
{
	int x,y;
};
typedef struct _POINT POINT;
POINT min={1,1};
char ConvHull(POINT* pts,short n,POINT* nfh,short* nnfh,POINT k);//not from hull...tuk slagame to4ki koito NE SA w obwivkata
int TanCmp(const void* x,const void* y);
inline void swap(POINT** buff1,POINT** buff2);
inline int PArea(POINT a,POINT o,POINT b);
int main()
{
	POINT pb1[MAXN],pb2[MAXN];
	POINT *buff1,*buff2;
	
	short i,n;
	POINT k;
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		scanf("%d%d",&(pb1[i].x),&(pb1[i].y));
		if(min.x>pb1[i].x||min.y>pb1[i].y)
			min=pb1[i];
	}
	i=0;
	min.x--;
	min.y--;
	//printf("min= %d %d\n",min.x,min.y);	
	for(i=0;i<n;i++)
	{
		pb1[i].x-=min.x;
		pb1[i].y-=min.y;
		//printf("p[]=%d %d\n",pb1[i].x,pb1[i].y);
	}
	scanf("%d",&i);
	i--;
	k=pb1[i];
	//printf("k=%d %d\n",k.x,k.y);
	buff1=pb1;
	buff2=pb2;
	i=0;
	//printf("startin\n");
	while(!ConvHull(buff1,n,buff2,&n,k))
	{
		swap(&buff1,&buff2);
		i++;
	}
	printf("%d\n",i);
	return 0;
}

char ConvHull(POINT* pts,short n,POINT* nfh,short* nnfh,POINT k)
{
	POINT hull[MAXN];
	int nh=0,i;
	char res=1;
	qsort(pts,n,sizeof(POINT),TanCmp);
	*nnfh=0;
	for(i=0;i<n;i++)
	{
		//printf("%d %d\n",pts[i].x+min.x,pts[i].y+min.y);
		while(PArea(hull[nh-2],hull[nh-1],pts[i])<0&&nh>1)
		{
			//printf("*");
			nh--;
			nfh[(*nnfh)++]=hull[nh];
			//printf("remove %d %d\n k=    %d %d\n",hull[nh].x,hull[nh].y,k.x,k.y);
			if(memcmp(&k,&hull[nh],sizeof(POINT))==0)
				res=0;
		}
		hull[nh++]=pts[i];
	}
	//printf("%d\n",res);
	return res;
}

int TanCmp(const void* x,const void* y)
{
	POINT* a=x;
	POINT* b=y;
	float res;
	return res=((float)a->y)/((float)a->x)-((float)b->y)/((float)b->x)?res:a->x>b->x;
}


inline void swap(POINT** buff1,POINT** buff2)
{
	POINT* buff=*buff1;
	*buff1=*buff2;
	*buff2=buff;
}


inline int PArea(POINT a,POINT o,POINT b)
{
	return (a.x-o.x)*(b.y-o.y)-(a.y-o.y)*(b.x-o.x);
}
